/***************************************************************************
                          dcchat.h  -  description
                             -------------------
    begin                : Don Mr 28 2002
    copyright            : (C) 2002 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DCCHAT_H
#define DCCHAT_H

/**
  *@author Mathias Kster
  */

#include <qwidget.h>
#include <qptrlist.h>
#include <qimage.h>
#include <qtextedit.h>

#include <dcconfig.h>

#include <DCDialogChat.h>

class DCClient;
class QStatusBar;
class QLabel;
class QPopupMenu;

class DCQTextEdit : public QTextEdit {
Q_OBJECT
public:
	/** */
	DCQTextEdit( QWidget * parent = 0, const char * name = 0 ) : QTextEdit( parent, name ) {};
	/** */
	virtual ~DCQTextEdit() {};

protected:
	/** */
	QPopupMenu * createPopupMenu( const QPoint & pos ) { emit rightButtonClicked(pos);return 0; };

signals:
	/** */
	void rightButtonClicked( const QPoint& );
};

class DCChat : public DCDialogChat  {
Q_OBJECT
public: 
	/** */
	DCChat( QWidget * parent, const char *name, int wflags, DCClient * client, bool bprivate = TRUE );
	/** */
	virtual ~DCChat();

	/** */
	void InitDocument();
	/** */
	DCClient * GetClient() { return m_pClient; };
	/** */
	void SetNick( QString nick, QString hubname );
	/** */
	QString GetNick() { return sNick; };
	/** */
	void AddMessage( QString nick, QString message, bool bremote = TRUE );
	/** */
	void AddMessage( CMessagePrivateChat * msg, bool bremote = TRUE );
	/** */
	void AddStatus( QString message );

	/** */
	bool close( bool alsoDelete = FALSE );

protected:
	/** event filter */
	virtual bool eventFilter( QObject * object, QEvent * event );

private:
	/** */
	void SetCrypt( bool b );
	/** */
	bool CheckForCommand();
	/** */
	QString GetTimeStamp();
	/** */
	void AddOutput( QString message );
	/** */
	void SendMessage();
	/** */
	int ConvertLinks( QString msg, QString & s );
	/** */
	int ConvertEmoticons( QString msg, QString & s );

	/** */
	DCQTextEdit * TextEdit_CHATOUTPUT;
	/** */
	QString m_sLanguage;
	/** */
	bool m_bPrivateChat;
	/** */
	bool bSendAway;
	/** */
	DCClient * m_pClient;
	/** */
	QString sNick;
	/** */
	QStatusBar * m_pStatusBar;
	/** */
	QLabel * m_pStatusCrypt;
	/** */
	int m_nEncrypted;
	/** */
	CList<CString> m_History;
	/** */
	CString * m_pCurrentHistory;

private slots:
	/** */
	void slotRightButtonClickedChatOutput( const QPoint& );
	/** */
	void slotClickedChatOutput( int, int );
	/** */
	void slotSendMessage();
};

#endif
