/***************************************************************************
                          dcfilebrowser.h  -  description
                             -------------------
    begin                : Fre Nov 29 2002
    copyright            : (C) 2002 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DCFILEBROWSER_H
#define DCFILEBROWSER_H

#include <qwidget.h>
#include <qlistview.h>

#include <DCDialogFileBrowser.h>

/**
  *@author Mathias Kster
  */

class DCFileItem : public QObject {
public:
	/** */
	DCFileItem() {};
	/** */
	virtual ~DCFileItem() {};

	/** */
	QString m_sName;
	/** */
	QString m_sSize;
};

class DCFileBrowserListItem : public QListViewItem {
public:
	/** */
	DCFileBrowserListItem( QListView * parent ) : QListViewItem(parent) {};
	/** */
	DCFileBrowserListItem( QListViewItem * parent ) : QListViewItem(parent) {};
	/** */
	virtual ~DCFileBrowserListItem() {};

	/** */
	QPtrList<DCFileItem> m_pFileList;
};


class DCFileBrowser : public DCDialogFileBrowser  {
   Q_OBJECT
public: 
	/** */
	DCFileBrowser(QWidget *parent=0, const char *name=0);
	/** */
	~DCFileBrowser();

	/** */
	void InitDocument();
	/** */
	void InitTree( QString nick, QString hubname, QString hubhost, QString s );

private:
	/** */
	QString m_sNick;
	/** */
	QString m_sHubName;
	/** */
	QString m_sHubHost;

private slots:
	/** */
	void slotCurrentChangedDirectory( QListViewItem * );
	/** */
	void slotExpandedDirectory( QListViewItem * );
	/** */
	void slotCollapsedDirectory( QListViewItem * );
};

#endif
