/***************************************************************************
                          dcspy.cpp  -  description
                             -------------------
    begin                : Fre Nov 8 2002
    copyright            : (C) 2002 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qregexp.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qtextedit.h>

#include <dcconfig.h>

#include "dcspy.h"

#include "res/spy.xpm"

DCSpy * pSpy = 0;

/** */
DCSpy::DCSpy(QWidget *parent, const char *name, int wflags) : DCDialogSpy(parent,name,wflags)
{
	// set default icon
	setIcon( QPixmap( spy_xpm ) );

	InitDocument();

	pSpy = this;
}

/** */
DCSpy::~DCSpy()
{
}

/** */
void DCSpy::InitDocument()
{
	StringMap * map;

	// restore settings
	if ( Config->GetMap("SPYVIEW",map) == TRUE )
	{
		if ( ((*map)["WIDTH"].toInt() > 0) && ((*map)["HEIGTH"].toInt() > 0) )
		{
			setGeometry( (*map)["X"].toInt(), (*map)["Y"].toInt(), (*map)["WIDTH"].toInt(), (*map)["HEIGTH"].toInt() );
		}
	}

	connect(PushButton_CLEAR, SIGNAL(clicked()), this, SLOT(slotClickedClear()) );
}

/** */
void DCSpy::DeInitDocument()
{
	StringMap * map;

	// save search view settings
	Config->GetMap("SPYVIEW",map);

	(*map)["X"]         = QString().setNum(x());
	(*map)["Y"]         = QString().setNum(y());
	(*map)["WIDTH"]     = QString().setNum(width());
	(*map)["HEIGTH"]    = QString().setNum(height());
	(*map)["VISIBLE"]   = QString().setNum(isVisible());
	(*map)["MAXIMIZED"] = QString().setNum(isMaximized());
	(*map)["MINIMIZED"] = QString().setNum(isMinimized());
	(*map)["ENABLED"]   = QString().setNum(isEnabled());
}

/** */
void DCSpy::slotClickedClear()
{
	TextEdit_SPY->clear();
}

/** search */
void DCSpy::DC_Search( CMessageSearch * MessageSearch )
{
	QString s;

	s = MessageSearch->sString.Data();
	s = s.replace( QRegExp("\\$"), " " );

	if ( CheckBox_ENABLESPY->isChecked() )
	{
		TextEdit_SPY->append(s);
	}
}
