/***************************************************************************
                          dcwidget.h  -  description
                             -------------------
    begin                : Don Mai 30 2002
    copyright            : (C) 2002 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DCWIDGET_H
#define DCWIDGET_H

#include <qlistview.h>
#include <qprogressbar.h>

#include <dclib/cmessagehandler.h>

/**
  *@author Mathias Kster
  */

class DC_QNumericSortItem {
public:
	/** */
	int mycol;
	/** */
	ulonglong myvalue;
	/** */
	DC_QNumericSortItem() { mycol=-1;myvalue=0; };
	/** */
	virtual ~DC_QNumericSortItem() {};
	/** */
	int mycompare( ulonglong v1, ulonglong v2, int col, bool ascending ) const;
};

class DC_QListViewItem : public QListViewItem, public DC_QNumericSortItem {
public:
	/** */
	DC_QListViewItem( QListView * parent ) : QListViewItem(parent) {};
	/** */
	DC_QListViewItem( QListViewItem * parent ) : QListViewItem(parent) {};
	/** */
	virtual ~DC_QListViewItem() {};
	/** */
	virtual int compare( QListViewItem * i, int col, bool ascending ) const;
	/** */
	virtual QString key( int column, bool ascending ) const;
};

class DC_ListResult : public DC_QListViewItem {
public:
        /** */
        DC_ListResult ( QListView * parent ) : DC_QListViewItem (parent) { };
        /** */
        DC_ListResult ( QListViewItem * parent ) : DC_QListViewItem (parent) { };
        /** */
        virtual ~DC_ListResult() { };
        /** */
        void paintCell( QPainter * p, const QColorGroup & cg, int column, int width, int align );
};

class DC_QCheckListItem : public QCheckListItem, public DC_QNumericSortItem {
public:
	/** */
	DC_QCheckListItem( QListView *parent, const QString &text, const QPixmap & );
	/** */
	virtual ~DC_QCheckListItem() {};
	/** */
	virtual void paintCell( QPainter * p, const QColorGroup & cg, int column, int width, int align );
	/** */
	QColor colorText;
	/** */
	virtual int compare( QListViewItem * i, int col, bool ascending ) const;
	/** */
	virtual QString key( int column, bool ascending ) const;
};

class DC_QProgressListItem : public QListViewItem
{
public:
	/** */
	enum Type { RadioButton, CheckBox, Controller, ProgressBar };
	/** */
	DC_QProgressListItem( DC_QProgressListItem *parent, const QString &text,
			      int co = 0, Type = ProgressBar );
	/** */
	DC_QProgressListItem( QListViewItem *parent, const QString &text,
			      int co = 0, Type = ProgressBar );
	/** */
	DC_QProgressListItem( QListView *parent, const QString &text,
			      int co = 0, Type = ProgressBar );
	/** */
	~DC_QProgressListItem();
	/** */
	void paintCell( QPainter *,  const QColorGroup & cg,
			int column, int width, int alignment );
	/** */
	virtual void paintFocus( QPainter *, const QColorGroup & cg,
					const QRect & r );
	/** */
	int width( const QFontMetrics&, const QListView*, int column) const;
	/** */
	void setup();

	Type type() const { return myType; }
	/** */
	QString text() const { return QListViewItem::text( 0 ); }
	/** */
	QString text( int n ) const { return QListViewItem::text( n ); }
	/** */
	int rtti() const;
	/** */
	static int RTTI;
	/** */
	void SetProgressEnable( bool b ) { m_bProgressEnable=b; }
	/** */
	void setProgress( int i ) { m_ProgressBar.setProgress(i); }

private:
	/** */
	void init();
	/** */
	Type myType;
	/** */
	DC_QProgressListItem *exclusive;
	/** */
	int m_nColumn;
	/** */
	bool m_bProgressEnable;
	/** */
	QProgressBar m_ProgressBar;
};

#endif
